HDU3038 How Many Answers Are Wrong —— 带权并查集

题目链接:http://acm.split.hdu.edu.cn/showproblem.php?pid=3038

How Many Answers Are Wrong

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 10164    Accepted Submission(s): 3699


Problem Description
TT and FF are ... friends. Uh... very very good friends -________-b

FF is a bad boy, he is always wooing TT to play the following game with him. This is a very humdrum game. To begin with, TT should write down a sequence of integers-_-!!(bored).

Then, FF can choose a continuous subsequence from it(for example the subsequence from the third to the fifth integer inclusively). After that, FF will ask TT what the sum of the subsequence he chose is. The next, TT will answer FF's question. Then, FF can redo this process. In the end, FF must work out the entire sequence of integers.

Boring~~Boring~~a very very boring game!!! TT doesn't want to play with FF at all. To punish FF, she often tells FF the wrong answers on purpose.

The bad boy is not a fool man. FF detects some answers are incompatible. Of course, these contradictions make it difficult to calculate the sequence.

However, TT is a nice and lovely girl. She doesn't have the heart to be hard on FF. To save time, she guarantees that the answers are all right if there is no logical mistakes indeed.

What's more, if FF finds an answer to be wrong, he will ignore it when judging next answers.

But there will be so many questions that poor FF can't make sure whether the current answer is right or wrong in a moment. So he decides to write a program to help him with this matter. The program will receive a series of questions from FF together with the answers FF has received from TT. The aim of this program is to find how many answers are wrong. Only by ignoring the wrong answers can FF work out the entire sequence of integers. Poor FF has no time to do this job. And now he is asking for your help~(Why asking trouble for himself~~Bad boy)
 
Input
Line 1: Two integers, N and M (1 <= N <= 200000, 1 <= M <= 40000). Means TT wrote N integers and FF asked her M questions.

Line 2..M+1: Line i+1 contains three integer: Ai, Bi and Si. Means TT answered FF that the sum from Ai to Bi is Si. It's guaranteed that 0 < Ai <= Bi <= N.

You can assume that any sum of subsequence is fit in 32-bit integer.
 
Output
A single line with a integer denotes how many answers are wrong.
 
Sample Input
10 5 1 10 100 7 10 28 1 3 32 4 6 41 6 6 1
 
Sample Output
1
 
Source
 
 
题解:
1.带权并查集(好像还叫做种类并查集, 我按我自己的理解,更喜欢称之为关系并查集)。
2.区间 [u,v]的和为w, 可以转化为: sigma(v)- sigma(u-1) = w。这样就可以把区间问题转化为两点问题,从而并查集派上用上了。
3.有n个数即n个点,每个结点i可以理解为前缀和sigma(x)。设fa[i]为结点i的父节点(并查集的做法);设r[i] = sigma(i)- sigma(fa[i]),即结点i比他的父节点大多少。
 
 
带权并查集:
 
  带权:r[]数组可以记录当前结点与父节点的关系,可以是大小关系(如此题), 可以是逻辑关系。对于相同的集合,由于在这棵树中,每个结点与父节点的关系已经确定,那么每个节点与集合中的其他结点的关系也可以一路推导出来。对于两个不同的集合,如果知道一对位于不同集合的结点的关系,那么这两个集合所有的结点之间的关系也可以推导出来了,即两个集合可以合并为一个集合。  
 
  路径压缩:对于被find()函数访问过的结点x, 它们的fa[x]都会直接指向根节点,同时需要更新r[x]数组(一路叠加)。问:那么对于被访问过的结点x的子树怎么办呢,不会被落下吗?答:结点x的子树的fa[]指针没有改变,仍然是指着x,即x的子树一直跟着x。
 
  合并:对于两个不同的集合,由于在对u、v调用find()函数时,u和v都分别指向了各自的根节点(路径压缩)。设fu为u所在集合的根节点(也是u的父节点), fv也如此,所以u和fu的关系即为r[u]、v和fv的关系即为r[v],且又知道u和v的关系, 那么就可以直接推出fu和fv的关系,这样就可以实现两个集合的合并。
 
 
 
代码如下:
 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstring>
 4 #include <cmath>
 5 #include <algorithm>
 6 #include <vector>
 7 #include <queue>
 8 #include <stack>
 9 #include <map>
10 #include <string>
11 #include <set>
12 #define ms(a,b) memset((a),(b),sizeof((a)))
13 using namespace std;
14 typedef long long LL;
15 const double EPS = 1e-8;
16 const int INF = 2e9;
17 const LL LNF = 2e18;
18 const int MAXN = 2e5+10;
19 
20 int n, m;
21 int fa[MAXN], r[MAXN];
22 
23 int find(int x)
24 {
25     if(fa[x]==-1) return x;
26     int pre = find(fa[x]);
27     r[x] += r[fa[x]];
28     return fa[x] = pre;
29 }
30 
31 bool Union(int u, int v, int w)
32 {
33     int fu = find(u);
34     int fv = find(v);
35     if(fu==fv)
36         return (r[v]-r[u]!=w);
37 
38     fa[fv] = fu;
39     r[fv] = -r[v]+w+r[u];
40     return false;
41 }
42 
43 int main()
44 {
45     while(scanf("%d%d", &n, &m)!=EOF)
46     {
47         memset(r, 0, sizeof(r));
48         memset(fa, -1, sizeof(fa));
49 
50         int ans = 0;
51         for(int i = 1; i<=m; i++)
52         {
53             int u, v, w;
54             scanf("%d%d%d", &u, &v, &w);
55             if(Union(u-1, v, w))
56                 ans++;
57         }
58         printf("%d
", ans);
59     }
60 }
View Code
原文地址:https://www.cnblogs.com/DOLFAMINGO/p/7652440.html